/*****************************************************************
 * Copyright 2012 Catalina Health Resource
 *
 * You are using this source code (and any object code
 * compiled therewith) under license.  This code is confidential
 * and proprietary.  All right, title, and interest in this code,
 * including copyrights, trade secrets, and patent rights belong
 * to Catalina Marketing Corporation.  By viewing and using this
 * code you acknowledge the confidential and proprietary nature
 * of the code, its trade secret status, and its copyrightability.
 *****************************************************************
 */
package objectdbevaluation;

import java.util.Random;
import java.util.concurrent.atomic.AtomicInteger;

public class EntityWriteTask extends Thread {

    private EntityWriteDAO dao;
    private AtomicInteger secondId;
    private int writeNumber;

    /**
     * {@inheritDoc}
     */
    @Override
    public void run() {

        Random random = new Random();

        try {
            dao.initialize();

            for(int i=0; i<writeNumber; i++) {

                TestEntity testEntity = new TestEntity();
                testEntity.setFirstId(1);
                testEntity.setSecondId(Integer.toString(secondId.getAndIncrement()));

                try {

                    testEntity.putObject("Key1", "Key2", "Key3", random.nextInt(100000000)+1);
                    dao.writeObject(testEntity);
                    Thread.sleep(50);

                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }

            dao.shutdown();
        } catch (Exception e) {
            System.out.println("DAO failed due to an exception.");
            e.printStackTrace();
        }
    }

    public void setDao(EntityWriteDAO dao) {
        this.dao = dao;
    }

    public void setWriteNumber(int writeNumber) {
        this.writeNumber = writeNumber;
    }

    public void setSecondId(AtomicInteger secondId) {
        this.secondId = secondId;
    }
}
